<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('HOME', '../');
define('PAGE', 'blogs/addpost.php');
define('TIME', microtime());

require ('../wb-includes/common.php');
require ('../wb-includes/plugins/blogs.php');

if (!$is_logged) {
	redirect('index.php');
}

if (isset($_POST['title'], $_POST['text'], $_POST['tags'])) {
	
	/**
	 * Добавление записи в коллективный блог
	 */
	if (isset($_POST['blog']) && is_unsigned($_REQUEST['blog'], true)) {
		$sql = 'select count(*) from ' . BLOGS_TABLE . ' 
		where blog_id = ' . ($blog_id = $_REQUEST['blog']);
		
		if (!mysql_result(mysql_query($sql), 0)) {
			redirect('addpost.php?w=1');
		}
		
		/**
		 * Проверка участия в блоге
		 */
		if (!$is_admin && !is_blog_user($blog_id, $user_id)) {
			/**
			 * Проверка участия в группе модераторов
			 * Если суммарные права доступа равны нулю - пользователь не участвует в группах модераторов
			 */
			if (array_sum(get_blogs_access($blog_id)) == 0) {
				redirect('addblog.php?w=1');
			}
		}
	} else {
		$blog_id = 0;
	}
	
	$text = cut($_POST['text'], get_option('length_blog_post'));
	$text = mysql_escape_string(check($text, true));
	
	$title = cut($_POST['title'], get_option('length_blog_post_title'));
	$title = mysql_escape_string(check($title));
	
	$count = 0;
	$tags = array();
	
	if (($t_tags = preg_split('/[\s]*[,][\s]*/', check($_POST['tags'])))) {
		foreach ($t_tags as $tag) {
			if (preg_match('/^[A-zА-я\d\s\-_]+$/u', $tag) && mb_strlen($tag) <= get_option('length_blog_tag')) {
				$tags[] = $tag;
			}
			
			if (++$count >= get_option('quota_blog_tags')) {
				break;
			}
		}
	}
	
	if ($blog_id) {
		/**
		 * Параметры записи блога группы
		 */
		$privacy_post = BLOG_POST_MEMBERS;
		$privacy_comments = BLOG_COMMENTS_MEMBERS;
		$privacy_comment = BLOG_COMMENT_MEMBERS;
		
		if ((isset($_POST['privacy_post']) && $_POST['privacy_post'] == BLOG_POST_USERS)) {
			$privacy_post = BLOG_POST_USERS;
		}
		
		if (isset($_POST['privacy_comments']) && ($_POST['privacy_comments'] == BLOG_COMMENTS_DISABLE || $_POST['privacy_comments'] == BLOG_COMMENTS_USERS)) {
			$privacy_comments = $_POST["privacy_comments"];
		}
		
		if (isset($_POST['privacy_comment']) && ($_POST['privacy_comment'] == BLOG_COMMENT_DISABLE || $_POST['privacy_comment'] == BLOG_COMMENT_USERS)) {
			$privacy_comment = $_POST['privacy_comment'];
		}
		
		/**
		 * Изменяем доступ к просмотру комментариев, взависимости от доступа к просмотру блога
		 */
		if ($privacy_post == BLOG_POST_MEMBERS && $privacy_comments != BLOG_COMMENTS_DISABLE) {
			$privacy_comments = BLOG_COMMENTS_MEMBERS;
		}
		
		/**
		 * Изменяем доступ к комментированию, взависимости от доступа к просмотру комментариев
		 */
		if ($privacy_comments == BLOG_COMMENTS_DISABLE) {
			$privacy_comment = BLOG_COMMENT_DISABLE;
		}
		
		if ($privacy_comments == BLOG_COMMENTS_MEMBERS && $privacy_comment != BLOG_COMMENT_DISABLE) {
			$privacy_comment = BLOG_COMMENT_MEMBERS;
		}
	} else {
		/**
		 * Параметры личной записи
		 */
		$privacy_post = BLOG_POST_USERS;
		$privacy_comments = BLOG_COMMENTS_USERS;
		$privacy_comment = BLOG_COMMENT_USERS;
		
		if (isset($_POST['privacy_post']) && ($_POST['privacy_post'] == BLOG_POST_FRIENDS || $_POST['privacy_post'] == BLOG_POST_F_FRIENDS)) {
			$privacy_post = $_POST['privacy_post'];
		}
		
		if (isset($_POST['privacy_comments']) && ($_POST['privacy_comments'] == BLOG_COMMENTS_DISABLE || $_POST['privacy_comments'] == BLOG_COMMENTS_FRIENDS || $_POST['privacy_comments'] == BLOG_COMMENTS_F_FRIENDS)) {
			$privacy_comments = $_POST["privacy_comments"];
		}
		
		if (isset($_POST['privacy_comment']) && ($_POST['privacy_comment'] == BLOG_COMMENT_DISABLE || $_POST['privacy_comment'] == BLOG_COMMENT_FRIENDS || $_POST['privacy_comment'] == BLOG_COMMENT_F_FRIENDS)) {
			$privacy_comment = $_POST['privacy_comment'];
		}
		
		/**
		 * Изменяем доступ к просмотру комментариев, взависимости от доступа к просмотру блога
		 */
		if ($privacy_post == BLOG_POST_FRIENDS && $privacy_comments != BLOG_COMMENTS_DISABLE) {
			$privacy_comments = BLOG_COMMENTS_FRIENDS;
		}
		
		if ($privacy_post == BLOG_POST_F_FRIENDS && $privacy_comments != BLOG_COMMENTS_DISABLE && $privacy_comments != BLOG_COMMENTS_FRIENDS) {
			$privacy_comments = BLOG_COMMENTS_F_FRIENDS;
		}
		
		/**
		 * Изменяем доступ к комментированию, взависимости от доступа к просмотру комментариев
		 */
		if ($privacy_comments == BLOG_COMMENTS_DISABLE) {
			$privacy_comment = BLOG_COMMENT_DISABLE;
		}
		
		if ($privacy_comments == BLOG_COMMENTS_FRIENDS && $privacy_comment != BLOG_COMMENT_DISABLE) {
			$privacy_comment = BLOG_COMMENT_FRIENDS;
		}
		
		if ($privacy_comments == BLOG_COMMENTS_F_FRIENDS && $privacy_comment != BLOG_COMMENT_DISABLE && $privacy_comment != BLOG_COMMENT_FRIENDS) {
			$privacy_comment = BLOG_COMMENT_F_FRIENDS;
		}
	}
	
	/**
	 * Проверка всех составляющих
	 */
	if ($title && $text && count($tags)) {
		/**
		 * Антифлуд
		 */
		if (($wait = antiflood())) {
			$expressions = array('секунду', 'секунды', 'секунд');
			
			echo '<p>' . "\n";
			echo 'Нельзя писать чаще чем раз в ' . get_option('flood_time') . ' ' . declension(get_option('flood_time'), $expressions) . '.<br />' . "\n";
			echo 'Подождите еще ' . $wait . ' ' . declension($wait, $expressions) . ', а потом <a href="addpost.php?' . ($blog_id ? 'w=1&amp;blog=' . $blog_id : 'w=0') . '">напишите снова</a>' . "\n";
			echo '</p>' . "\n";
		} else {
			$sql = 'insert into ' . BLOG_POSTS_TABLE . ' (
			blog_id,
			user_id,
			post_add_time,
			post_title,
			post_tags,
			post_text,
			privacy_post,
			privacy_comments,
			privacy_comment
			) values (
			' . ($blog_id ? $blog_id : '0') . ',
			' . $user_id . ',
			' . time() . ',
			"' . $title . '",
			"' . implode(', ', $tags) . '",
			"' . $text . '",
			"' . $privacy_post . '",
			"' . $privacy_comments . '",
			"' . $privacy_comment . '"
			)';
			
			mysql_query($sql);
			
			$post_id = mysql_insert_id();
			insert_post_tags($post_id, $tags);
			
			update_antiflood();
			update_user_count_posts($user_id);
			
			echo '<p>' . "\n";
			echo 'Запись добавлена<br />' . "\n";
			echo '<a href="post.php?post=' . $post_id . '">Посмотреть на запись</a><br />' . "\n";
			echo '<a href="addpost.php?' . ($blog_id ? 'w=1&amp;blog=' . $blog_id : 'w=0') . '">Написать еще</a>';
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Вы не ввели тему, сообщение или метку.<br />' . "\n";
		echo '<a href="addpost.php?' . ($blog_id ? 'w=1&amp;blog=' . $blog_id : 'w=0') . '">Назад</a>';
		echo '</p>' . "\n";
	}
	
} elseif (isset($_GET['w'])) {
	
	if (($wait = antiflood())) {
		echo '<p><span id="info">' . "\n";
		echo 'Действие антифлуда закончится через ' . $wait . ' ' . declension($wait, array('секунду', 'секунды', 'секунд'));
		echo '</span></p>' . "\n";
	}
	
	$privacy_post = $_GET['w'] ? BLOG_POST_MEMBERS : BLOG_POST_USERS;
	$privacy_comments = $_GET['w'] ? BLOG_COMMENTS_MEMBERS : BLOG_COMMENTS_USERS;
	$privacy_comment = $_GET['w'] ? BLOG_COMMENT_MEMBERS : BLOG_COMMENT_USERS;
	
	echo '<form action="addpost.php" method="post">' . "\n";
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Добавление записи' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	if ($_GET['w']) {
		if (!$is_admin) {
			$sql = 'select b.blog_id, b.blog_name 
			from ' . BLOGS_USER_TABLE . ' as u 
			inner join ' . BLOGS_TABLE . ' as b using (blog_id) 
			where u.user_id = ' . $user_id . ' and u.is_entry = "0"';
		} else {
			$sql = 'select blog_id, blog_name from ' . BLOGS_TABLE;
		}
		
		$query = mysql_query($sql);
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		
		if (mysql_num_rows($query)) {
			$blog_id = isset($_GET['blog']) && is_unsigned($_GET['blog'], true) ? $_GET['blog'] : 0;
			
			echo 'Выберите блог:<br />' . "\n";
			echo '<select name="blog">' . "\n";
			
			while ($row = mysql_fetch_row($query)) 
				echo '<option value="' . $row[0] . '"' . ($row[0] == $blog_id ? ' selected="selected"' : '') . '>' . $row[1] . '</option>' . "\n";
			
			echo '</select>' . "\n";
		} else {
			echo 'Вы не участвуете в коллективных блогах!<br />' . "\n";
			echo '<a href="addpost.php">Назад</a>' . "\n";
		}
		
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Тема:<br />' . "\n";
	echo '<span id="info">Не более ' . get_option('length_blog_post_title') . ' символов</span><br />';
	echo '<input type="text" name="title" size="40" maxlength="' . get_option('length_blog_post_title')  . '" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Сообщение:<br />' . "\n";
	echo '<span id="info">Не более ' . get_option('length_blog_post') . ' символов</span><br />';
	echo '<textarea name="text" maxlength="' . get_option('length_blog_post') . '" ' . get_option('textarea_attributes') . '></textarea>' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Метки:<br />' . "\n";
	echo '<span id="info">Не более ' . get_option('quota_blog_tags') . ' ' . declension(get_option('quota_blog_tags'), array('метка', 'меток')) . '. Метки нужно разделять запятой</span><br />' . "\n";
	echo '<input type="text" name="tags" size="40" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	if ($_GET['w']) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Кто может просматривать эту запись:<br />' ."\n";
		echo '<input type="radio" name="privacy_post" value="' . BLOG_POST_MEMBERS . '"' . ($privacy_post == BLOG_POST_MEMBERS ? ' checked="checked"' : '') . ' /> Читатели блога<br />' . "\n";
		echo '<input type="radio" name="privacy_post" value="' . BLOG_POST_USERS . '"' . ($privacy_post == BLOG_POST_USERS ? ' checked="checked"' : '') . ' /> Все пользователи' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Кто может просматривать комментарии к этой записи:<br />' ."\n";
		echo '<input type="radio" name="privacy_comments" value="' . BLOG_COMMENTS_DISABLE . '"' . ($privacy_comments == BLOG_COMMENTS_DISABLE ? ' checked="checked"' : '') . ' /> Выключить обсуждение<br />' . "\n";
		echo '<input type="radio" name="privacy_comments" value="' . BLOG_COMMENTS_MEMBERS . '"' . ($privacy_comments == BLOG_COMMENTS_MEMBERS ? ' checked="checked"' : '') . ' /> Читатели блога<br />' . "\n";
		echo '<input type="radio" name="privacy_comments" value="' . BLOG_COMMENTS_USERS . '"' . ($privacy_comments == BLOG_COMMENTS_USERS ? ' checked="checked"' : '') . ' /> Все пользователи' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Кто может может комментировать эту запись:<br />' ."\n";
		echo '<input type="radio" name="privacy_comment" value="' . BLOG_COMMENT_DISABLE . '"' . ($privacy_comment == BLOG_COMMENT_DISABLE ? ' checked="checked"' : '') . ' /> Выключить обсуждение<br />' . "\n";
		echo '<input type="radio" name="privacy_comment" value="' . BLOG_COMMENT_MEMBERS . '"' . ($privacy_comment == BLOG_COMMENT_MEMBERS ? ' checked="checked"' : '') . ' /> Читатели блога<br />' . "\n";
		echo '<input type="radio" name="privacy_comment" value="' . BLOG_COMMENT_USERS . '"' . ($privacy_comment == BLOG_COMMENT_USERS ? ' checked="checked"' : '') . ' /> Все пользователи' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	} else {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Кто может просматривать эту запись:<br />' ."\n";
		echo '<input type="radio" name="privacy_post" value="' . BLOG_POST_FRIENDS . '"' . ($privacy_post == BLOG_POST_FRIENDS ? ' checked="checked"' : '') . ' /> Только мои друзья<br />' . "\n";
		echo '<input type="radio" name="privacy_post" value="' . BLOG_POST_F_FRIENDS  . '"' . ($privacy_post == BLOG_POST_F_FRIENDS ? ' checked="checked"' : '') . ' /> Мои друзья и друзья друзей<br />' . "\n";
		echo '<input type="radio" name="privacy_post" value="' . BLOG_POST_USERS . '"' . ($privacy_post == BLOG_POST_USERS ? ' checked="checked"' : '') . ' /> Все пользователи<br />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Кто может просматривать комментарии к этой записи:<br />' ."\n";
		echo '<input type="radio" name="privacy_comments" value="' . BLOG_COMMENTS_DISABLE . '"' . ($privacy_comments == BLOG_COMMENTS_DISABLE ? ' checked="checked"' : '') . ' /> Выключить обсуждение<br />' . "\n";
		echo '<input type="radio" name="privacy_comments" value="' . BLOG_COMMENTS_FRIENDS . '"' . ($privacy_comments == BLOG_COMMENTS_FRIENDS ? ' checked="checked"' : '') . ' /> Только мои друзья<br />' . "\n";
		echo '<input type="radio" name="privacy_comments" value="' . BLOG_COMMENTS_F_FRIENDS . '"' . ($privacy_comments == BLOG_COMMENTS_F_FRIENDS ? ' checked="checked"' : '') . ' /> Мои друзья и друзья друзей<br />' . "\n";
		echo '<input type="radio" name="privacy_comments" value="' . BLOG_COMMENTS_USERS . '"' . ($privacy_comments == BLOG_COMMENTS_USERS ? ' checked="checked"' : '') . ' /> Все пользователи<br />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Кто может может комментировать эту запись:<br />' ."\n";
		echo '<input type="radio" name="privacy_comment" value="' . BLOG_COMMENT_DISABLE . '"' . ($privacy_comment == BLOG_COMMENT_DISABLE ? ' checked="checked"' : '') . ' /> Выключить обсуждение<br />' . "\n";
		echo '<input type="radio" name="privacy_comment" value="' . BLOG_COMMENT_FRIENDS . '"' . ($privacy_comment == BLOG_COMMENT_FRIENDS ? ' checked="checked"' : '') . ' /> Только мои друзья<br />' . "\n";
		echo '<input type="radio" name="privacy_comment" value="' . BLOG_COMMENT_F_FRIENDS . '"' . ($privacy_comment == BLOG_COMMENT_F_FRIENDS ? ' checked="checked"' : '') . ' /> Мои друзья и друзья друзей<br />' . "\n";
		echo '<input type="radio" name="privacy_comment" value="' . BLOG_COMMENT_USERS . '"' . ($privacy_comment == BLOG_COMMENT_USERS ? ' checked="checked"' : '') . ' /> Все пользователи<br />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '<tr>' . "\n";
	echo '<td id="sub">' . "\n";
	echo '<input type="submit" value="Добавить" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	echo '</form>' . "\n";
} else {
	echo '<p>' . "\n";
	echo '<a href="addpost.php?w=1">Добавить запись в коллективный блог</a><br />' . "\n";
	echo '<a href="addpost.php?w=0">Добавить запись в личный блог</a>' . "\n";
	echo '</p>' . "\n";
}

close(
	'Добавление записи', 
	'Добавление записи', 
	'<a href="index.php">К блогам</a><br />' . "\n" . '<a href="../index.php">На главную</a>'
);
?>