<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define("IN_WBENGINE", 1);
define("PAGE", "register.php");
define("TIME", microtime());

require("wb-includes/common.php");

if ($is_logged) {
	redirect("index.php");
}

if (!get_option('allow_registration')) {
	/**
	 * Регистрация закрыта
	 */
	echo '<p>' . "\n";
	echo 'Извините, но регистрация временно закрыта, попробуйте зарегистрироваться позже' . "\n";
	echo '</p>' . "\n";
} elseif (isset($_REQUEST['next'])) {
	/**
	 * Проверка данных, добавление записи в таблице
	 */
	
	$login = $password = $email = '';
	$sex = 'm';
	
	if (isset($_POST['login'])) {
		$login = check($_POST['login']);
		$login = str_replace(' ', '_', $login);
	}
	
	if (isset($_POST['password'])) {
		$password = check($_POST['password']);
	}
	
	if (isset($_POST['email'])) {
		$email = check($_POST['email']);
		$email = strtolower($email);
	}
	
	if (isset($_POST['sex']) && preg_match('/^f|m$/', $_POST['sex'])) {
		$sex = $_POST['sex'];
	}
	
	$errors = array();
	
	if ($login && $password && $email) {
		if (!preg_match('/^[A-z0-9\-_]+$/', $login)) {
			$errors[] = 'В логине недопустимые символы';
		}
		
		if (preg_match('/^0-9+$/', $login)) {
			$errors[] = 'Логин не может быть числом';
		}
		
		if (!preg_match('/^[A-z0-9]+$/', $password)) {
			$errors[] = 'В пароле недопустимые символы';
		}
		
		if (!preg_match('/^[\.A-z\d_\-]+[@][A-z\d_\-]+([.][A-z\d_\-]+)+[A-z]{1,4}$/', $email)) {
			$errors[] = 'Неверный формат e-mail';
		}
		
		if (strlen($login) > 25) {
			$errors[] = 'Длина логина превышает 25 символов';
		}
		
		if (strlen($password) > 25) {
			$errors[] = 'Длина пароля превышает 25 символов';
		}
		
		if (strlen($email) > 80) {
			$errors[] = 'Длина адреса e-mail превышает 80 символов';
		}
		
		if (mysql_result(mysql_query('select count(*) from ' . USERS_TABLE . ' where user_login = "' . mysql_escape_string($login) . '"'), 0)) {
			$errors[] =  'Логин ' . $login . ' занят, выберите другой';
		}
		
		if (mysql_result(mysql_query('select count(*) from ' . USERS_TABLE . ' where user_email = "' . mysql_escape_string($email) . '"'), 0)) {
			$errors[] =  'Email ' . $email . ' уже используется';
		}
	} else {
		$errors[] = 'Не указан логин, пароль или e-mail';
	}
	
	if (!get_captcha_code() || $_POST['num'] != get_captcha_code()) {
		$errors[] =	'Проверочное число неверно';
	}
	
	if (count($errors)) {
		/**
		 * Найдены ошибки
		 */
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Регистрация' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'В ходе обработки Вашей регистрации были найдены ошибки:<br />' . "\n";
		
		foreach ($errors as $err) {
			echo  $err . '<br />' . "\n";
		}
		
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '</table>' . "\n";
		
		echo '<p>' . "\n";
		echo '<a href="register.php">Назад</a>' . "\n";
		echo '</p>' . "\n";
	} else {
		/**
		 * Уничтожение записи кода в sessions
		 */
		delete_captcha_code();
		
		/**
		 * Добавление записи в БД
		 */
		
		$sql = 'insert into ' . USERS_TABLE . ' (
		user_login,
		user_password,
		user_email,
		user_register,
		user_last_visit,
		user_theme,
		user_nav_posts,
		user_nav_comments
		) values (
		"' . $login . '",
		"' . md5(md5($password)) . '",
		"' . $email . '",
		"' . time() . '",
		"' . time() . '",
		"' . get_option('theme') . '",
		"' . get_option('nav_posts') . '",
		"' . get_option('nav_commentaries') . '"
		)';
		
		mysql_query($sql);
		
		echo '<form action="login.php" method="post">' . "\n";
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Регистрация' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Вы успешно зарегистрировались!<br />' . "\n";
		echo 'На указанный e-mail отправлены регистрационные данные<br />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Ваши данные:<br />' . "\n";
		echo 'Логин: ' . $login . '<br />' . "\n";
		echo 'Пароль: ' . $password . '<br />' . "\n";
		echo 'E-mail: ' . $email . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo '<input type="hidden" name="l" value="' . $login . '" />' . "\n";
		echo '<input type="hidden" name="p" value="' . $password . '" />' . "\n";
		echo '<input type="checkbox" name="cookie" checked="checked" /> Запомнить меня<br />' . "\n";
		echo '<input type="submit" value="Авторизация" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '</table>' . "\n";
		echo '</form>' . "\n";
		
		/**
		 * Отправка email
		 */
		$url = get_option('http_home_url');
		$message = <<<MAIL
Это письмо отправлено с сайта {$url}
Вы получили это письмо, так как этот e-mail адрес был использован при регистрации на сайте. Если Вы не регистрировались на этом сайте, просто проигнорируйте это письмо и удалите его. Вы больше не получите такого письма.

------------------------
Авторизация
------------------------
Ваш логин: {$login}
Ваш пароль: {$password}

------------------------
Автологин
------------------------
Для посещения сайта можете воспользоваться закладкой:
{$url}/login.php?l={$login}&p={$password}

С уважением, Aдминистрация сайта.
MAIL;
		
		send_mail($email, get_option('admin_email'), 'Регистрация', $message);
	}
} else {
	/**
	 * Отображение формы регистрации
	 */
	echo '<form action="register.php?next" name="register" method="post">' . "\n";
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Регистрация' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Логин:<br />' . "\n";
	echo '<span id="info">Не более 25 символов</span><br />' . "\n";
	echo '<input type="text" maxlength="25" name="login" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Пароль:<br />' . "\n";
	echo '<span id="info">Не более 25 символов</span><br />' . "\n";
	echo '<input type="text" maxlength="25" name="password" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Email:<br />' . "\n";
	echo '<span id="info">Не более 80 символов</span><br />' . "\n";
	echo '<input type="text" maxlength="80" name="email" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Пол:<br />' . "\n";
	echo '<input type="radio" name="sex" value="m" /> ' . get_option('man') . '<br />' . "\n";
	echo '<input type="radio" name="sex" value="f" /> ' . get_option('woman') . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Проверочный код:<br />' . "\n";
	echo '<img src="wb-includes/antibot.php" alt="Captcha" /><br />' . "\n";
	echo '<input type="text" name="num" size="5" maxlength="5" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="sub">' . "\n";
	echo '<input type="submit" name="next" value="Далее" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	echo '</form>' . "\n";
}

close ('Регистрация', 'Регистрация', '<a href="index.php">На главную</a>' . "\n");
?>