<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('ONLY_LOGGED', 1);
define('PAGE', 'settings.php');
define('TIME', microtime());

require('wb-includes/common.php');

if (isset($_POST['theme'])) {
	/**
	 * Стандартные параметры
	 */
	
	$nav_comments = (int) get_option("nav_comments");
	$nav_posts = (int) get_option("nav_posts");
	$theme = get_option("theme");
	$friends_privacy = FRIENDS_USERS;
	$friendship_privacy = FRIENDSHIP_USERS;
	$privmsgs_privacy = PRIVMSGS_USERS;
	$wall_privacy = WALL_USERS;
	$wall_posting_privacy = WALL_POSTING_USERS;
	$email_privacy = 0;
	$privmsgs_to_email = 0;
	$allow_cookies = 1;
	$allow_translit = 0;
	$allow_images = 1;
	$hide_online = 0;
	$date_adjust = 0;
	
	if (!isset($_POST['reset']) && !empty($_POST['theme'])) {
		/**
		 * Получение и обработка параметров
		 */
		
		$allow_cookies = (int) !empty($_POST['allow_cookies']);
		$allow_translit = (int) !empty($_POST['allow_translit']);
		$allow_images = (int) !empty($_POST['allow_images']);
		$hide_online = (int) !empty($_POST['hide_online']);
		$privmsgs_to_email = (int) !empty($_POST['privmsgs_to_email']);
		$email_privacy = (int) !empty($_POST['email_privacy']);
		$group_entries_privacy = (int) !empty($_POST['group_entries_privacy']);
		
		if (in_array($_POST["theme"], get_themes())) {
			$theme = $_POST["theme"];
		}
		
		if (!empty($_POST['nav_comments']) && is_unsigned($_POST['nav_comments'], true) && $_POST['nav_comments'] <= 50) {
			$nav_comments = $_POST['nav_comments'];
		}
		
		if (!empty($_POST['nav_posts']) && is_unsigned($_POST['nav_posts'], true) && $_POST['nav_posts'] <= 50) {
			$nav_posts = $_POST['nav_posts'];
		}
		
		if (isset($_POST['date_adjust']) && preg_match('/^(-)?\d{1,2}$/', $_POST['date_adjust'])) {
			$date_adjust = $_POST['date_adjust'];
		}
		
		if (isset($_POST['friends_privacy']) && in_array($_POST['friends_privacy'], array(FRIENDS_ME, FRIENDS_FRIENDS, FRIENDS_F_FRIENDS))) {
			$friends_privacy = $_POST['friends_privacy'];
		}
		
		if (isset($_POST['privmsgs_privacy']) && in_array($_POST['privmsgs_privacy'], array(PRIVMSGS_FRIENDS, PRIVMSGS_F_FRIENDS))) {
			$privmsgs_privacy = $_POST['privmsgs_privacy'];
		}
		
		if (isset($_POST['friendship_privacy']) && in_array($_POST['friendship_privacy'], array(FRIENDSHIP_DISABLE, FRIENDSHIP_USERS_WITH_ENTRY))) {
			$friendship_privacy = $_POST['friendship_privacy'];
		}
		
		if (isset($_POST['wall_privacy']) && in_array($_POST['wall_privacy'], array(WALL_ME, WALL_FRIENDS, WALL_F_FRIENDS))) {
			$wall_privacy = $_POST['wall_privacy'];
		}
		
		if (isset($_POST['wall_posting_privacy']) && in_array($_POST['wall_posting_privacy'], array(WALL_POSTING_ME, WALL_POSTING_FRIENDS, WALL_POSTING_F_FRIENDS))) {
			$wall_posting_privacy = $_POST['wall_posting_privacy'];
		}
		
		if ($wall_privacy < $wall_posting_privacy) {
			$wall_posting_privacy = $wall_privacy;
		}
	}
	
	/**
	 * Сохранение параметров
	 */
	$sql = 'update ' . USERS_TABLE . ' set
	user_date_adjust = "' . $date_adjust . '",
	user_nav_comments = ' . $nav_comments . ',
	user_nav_posts = ' . $nav_posts . ',
	user_privmsgs_to_email = "' . $privmsgs_to_email . '",
	user_privmsgs_privacy = "' . $privmsgs_privacy . '",
	user_email_privacy = "' . $email_privacy . '",
	user_friends_privacy = "' . $friends_privacy . '",
	user_friendship_privacy = "' . $friendship_privacy . '",
	user_wall_privacy = "' . $wall_privacy . '",
	user_wall_posting_privacy = "' . $wall_posting_privacy . '",
	user_allow_translit = "' . $allow_translit . '",
	user_allow_cookies = "' . $allow_cookies . '",
	user_allow_images = "' . $allow_images . '",
	user_hide_online = "' . $hide_online . '",
	user_theme = "' . $theme . '"
	where user_id = ' . $user_id;
	
	mysql_query($sql);
	
	echo '<p>' . "\n";
	echo 'Настройки ' . (isset($_POST['reset']) ? 'сброшены' : 'изменены') . '<br />' . "\n";
	echo '<a href="settings.php">Вернуться</a>' . "\n";
	echo '</p>' . "\n";
} else {
	echo '<form action="settings.php" method="post">' . "\n";
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Настройки' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Тема:<br />' . "\n";
	echo '<select name="theme">' . "\n";
	
	foreach (get_themes() as $theme) {
		echo '<option value="' . $theme . '"' . ($theme == $user_data['user_theme'] ? ' selected="selected"' : '') . '>' . $theme . '</option>' . "\n";
	}
	
	echo '</select>' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Часовой пояс:<br />' . "\n";
	echo '<input type="text" name="date_adjust" value="' . ($user_data['user_date_adjust'] > 0 ? '+' : '') . $user_data['user_date_adjust'] . '" size="3" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Отображать checkbox\'ы транслита:<br />' ."\n";
	echo '<input type="radio" name="allow_translit" value="1" ' . ($user_data['user_allow_translit'] ? 'checked="checked" ' : '') . '/> Да ' . "\n";
	echo '<input type="radio" name="allow_translit" value="0" ' . (!$user_data['user_allow_translit'] ? 'checked="checked" ' : '') . '/> Нет' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Копировать приватные сообщения на E-mail:<br />' ."\n";
	echo '<input type="radio" name="privmsgs_to_email" value="1" ' . ($user_data['user_privmsgs_to_email'] ? 'checked="checked" ' : '') . '/> Да ' . "\n";
	echo '<input type="radio" name="privmsgs_to_email" value="0" ' . (!$user_data['user_privmsgs_to_email'] ? 'checked="checked" ' : '') . '/> Нет' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Показ изображений:<br />' ."\n";
	echo '<input type="radio" name="allow_images" value="1" ' . ($user_data['user_allow_images'] ? 'checked="checked" ' : '') . '/> Да ' . "\n";
	echo '<input type="radio" name="allow_images" value="0" ' . (!$user_data['user_allow_images'] ? 'checked="checked" ' : '') . '/> Нет' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Скрывать мое присутствие на сайте:<br />' ."\n";
	echo '<span id="info">Другие пользователи не смогут увидить Вас</span><br />' . "\n";
	echo '<input type="radio" name="hide_online" value="1" ' . ($user_data['user_hide_online'] ? 'checked="checked" ' : '') . '/> Да ' . "\n";
	echo '<input type="radio" name="hide_online" value="0" ' . (!$user_data['user_hide_online'] ? 'checked="checked" ' : '') . '/> Нет' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Разрешить авторизацию с помощью cookies:<br />' ."\n";
	echo '<span id="info">При посещении сайта будет производиться автоматическая авторизация</span><br />' . "\n";
	echo '<input type="radio" name="allow_cookies" value="1" ' . ($user_data['user_allow_cookies'] ? 'checked="checked" ' : '') . '/> Да ' . "\n";
	echo '<input type="radio" name="allow_cookies" value="0" ' . (!$user_data['user_allow_cookies'] ? 'checked="checked" ' : '') . '/> Нет' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Кто может просмотреть мой Email:<br />' . "\n";
	echo '<input type="radio" name="email_privacy" value="0" ' . (!$user_data['user_email_privacy'] ? 'checked="checked" ' : '') . '/> Никто ' . "\n";
	echo '<input type="radio" name="email_privacy" value="1" ' . ($user_data['user_email_privacy'] ? 'checked="checked" ' : '') . '/> Все пользователи' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Кто может смотреть список моих друзей:<br />' ."\n";
	echo '<input type="radio" name="friends_privacy" value="' . FRIENDS_ME . '" ' . ($user_data['user_friends_privacy'] == FRIENDS_ME ? 'checked="checked" ' : '') . '/> Только я<br />' . "\n";
	echo '<input type="radio" name="friends_privacy" value="' . FRIENDS_FRIENDS . '" ' . ($user_data['user_friends_privacy'] == FRIENDS_FRIENDS ? 'checked="checked" ' : '') . '/> Только мои друзья<br />' . "\n";
	echo '<input type="radio" name="friends_privacy" value="' . FRIENDS_F_FRIENDS . '" ' . ($user_data['user_friends_privacy'] == FRIENDS_F_FRIENDS ? 'checked="checked" ' : '') . '/> Мои друзья и друзья друзей<br />' . "\n";
	echo '<input type="radio" name="friends_privacy" value="' . FRIENDS_USERS . '" ' . ($user_data['user_friends_privacy'] == FRIENDS_USERS ? 'checked="checked" ' : '') . '/> Все пользователи' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Кто может добавлять меня в друзья:<br />' ."\n";
	echo '<input type="radio" name="friendship_privacy" value="' . FRIENDSHIP_DISABLE . '" ' . ($user_data['user_friendship_privacy'] == FRIENDSHIP_DISABLE ? 'checked="checked" ' : '') . '/> Никто<br />' . "\n";
	echo '<input type="radio" name="friendship_privacy" value="' . FRIENDSHIP_USERS_WITH_ENTRY . '" ' . ($user_data['user_friendship_privacy'] == FRIENDSHIP_USERS_WITH_ENTRY ? 'checked="checked" ' : '') . '/> Все пользователи (необходима Ваша предмодерация)<br />' . "\n";
	echo '<input type="radio" name="friendship_privacy" value="' . FRIENDSHIP_USERS . '" ' . ($user_data['user_friendship_privacy'] == FRIENDSHIP_USERS ? 'checked="checked" ' : '') . '/> Все пользователи<br />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Кто может отправить мне приватное сообщение:<br />' ."\n";
	echo '<input type="radio" name="privmsgs_privacy" value="' . PRIVMSGS_FRIENDS . '" ' . ($user_data['user_privmsgs_privacy'] == PRIVMSGS_FRIENDS ? 'checked="checked" ' : '') . '/> Только мои друзья<br />' . "\n";
	echo '<input type="radio" name="privmsgs_privacy" value="' . PRIVMSGS_F_FRIENDS . '" ' . ($user_data['user_privmsgs_privacy'] == PRIVMSGS_F_FRIENDS ? 'checked="checked" ' : '') . '/> Мои друзья и друзья друзей<br />' . "\n";
	echo '<input type="radio" name="privmsgs_privacy" value="' . PRIVMSGS_USERS . '" ' . ($user_data['user_privmsgs_privacy'] == PRIVMSGS_USERS ? 'checked="checked" ' : '') . '/> Все пользователи<br />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Кто может смотреть содержимое моей стены:<br />' ."\n";
	echo '<input type="radio" name="wall_privacy" value="' . WALL_ME . '" ' . ($user_data['user_wall_privacy'] == WALL_ME ? 'checked="checked" ' : '') . '/> Только я<br />' . "\n";
	echo '<input type="radio" name="wall_privacy" value="' . WALL_FRIENDS . '" ' . ($user_data['user_wall_privacy'] == WALL_FRIENDS ? 'checked="checked" ' : '') . '/> Только мои друзья<br />' . "\n";
	echo '<input type="radio" name="wall_privacy" value="' . WALL_F_FRIENDS  . '" ' . ($user_data['user_wall_privacy'] == WALL_F_FRIENDS ? 'checked="checked" ' : '') . '/> Мои друзья и друзья друзей<br />' . "\n";
	echo '<input type="radio" name="wall_privacy" value="' . WALL_USERS . '" ' . ($user_data['user_wall_privacy'] == WALL_USERS ? 'checked="checked" ' : '') . '/> Все пользователи<br />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Кто может добавлять сообщения на мою стену:<br />' ."\n";
	echo '<input type="radio" name="wall_posting_privacy" value="' . WALL_POSTING_ME . '" ' . ($user_data['user_wall_posting_privacy'] == WALL_POSTING_ME ? 'checked="checked" ' : '') . '/> Только я<br />' . "\n";
	echo '<input type="radio" name="wall_posting_privacy" value="' . WALL_POSTING_FRIENDS . '" ' . ($user_data['user_wall_posting_privacy'] == WALL_POSTING_FRIENDS ? 'checked="checked" ' : '') . '/> Только мои друзья<br />' . "\n";
	echo '<input type="radio" name="wall_posting_privacy" value="' . WALL_POSTING_F_FRIENDS . '" ' . ($user_data['user_wall_posting_privacy'] == WALL_POSTING_F_FRIENDS ? 'checked="checked" ' : '') . '/> Мои друзья и друзья друзей<br />' . "\n";
	echo '<input type="radio" name="wall_posting_privacy" value="' . WALL_POSTING_USERS . '" ' . ($user_data['user_wall_posting_privacy'] == WALL_POSTING_USERS ? 'checked="checked" ' : '') . '/> Все пользователи<br />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Отображать постов на страницу:<br />' . "\n";
	echo '<span id="info">От 1 до 50</span><br />' . "\n";
	echo '<input type="text" name="nav_posts" value="' . $user_data['user_nav_posts'] . '" size="3" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Отображать комментариев на страницу:<br />' . "\n";
	echo '<span id="info">От 1 до 50</span><br />' . "\n";
	echo '<input type="text" name="nav_comments" value="' . $user_data['user_nav_comments'] . '" size="3" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="sub">' . "\n";
	echo '<input type="submit" value="Изменить" />' . "\n";
	echo '<input type="submit" name="reset" value="Сброс" /> ' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	echo '</form>' . "\n";
}

close('Настройки', 'Настройки', '<a href="usercp.php">В кабинет</a><br />' . "\n" . '<a href="index.php">На главную</a>');
?>