<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('ONLY_LOGGED', 1);
define('PAGE', 'users.php');
define('TIME', microtime());

require ('wb-includes/common.php');

/**
 * Параметры сортировки
 */
$search = '';
$allowed_modes = array('user_login', 'user_register', 'user_count_posts', 'user_count_comments');
$allowed_orders = array('asc', 'desc');

if (isset($_REQUEST['mode'], $_REQUEST['order'])) {
	$mode = in_array($_REQUEST['mode'], $allowed_modes) ? $_REQUEST['mode'] : 'user_login';
	$order = in_array($_REQUEST['order'], $allowed_orders) ? $_REQUEST['order'] : 'user_login';
	
	$_SESSION['users_sort'] = serialize(array($mode, $order));
	
} elseif (!empty($_SESSION['users_sort']) && (list($mode, $order) = @unserialize($_SESSION['users_sort']))) {
	$mode = in_array($mode, $allowed_modes) ? $mode : 'user_login';
	$order = in_array($order, $allowed_orders) ? $order : 'asc';
} else {
	$mode = 'user_login';
	$order = 'asc';
}


if (isset($_REQUEST['search'])) {
	/**
	 * Поиск пользователя
	 */
	
	$theme = array (
		'Поиск',
		'Поиск пользователя',
		'<a href="users.php">Пользователи</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	if ($_REQUEST['search'] == '') {
		echo '<form action="users.php" name="search" method="post">' . "\n";
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Поиск пользователя';
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Логин или ID пользователя:<br />' . "\n";
		echo '<input type="text" name="search" value="' . $search . '" /> ' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Для поиска можно использовать знаки * - заменяет произвольное число символов, и _ - заменяет один символ. ' . "\n";
		echo 'Например, запрос "_asha" найдет пользователей с никами "Sasha", "Masha", ' . "\n";
		echo 'а запрос "Vas*" найдет пользователей с никами "Vasya", "Vasylysa", "Vasysualy_Pupkin".' . "\n";
		echo 'Также можно комбинировать эти знаки - запрос "_a*a" найдет пользователей "Sasha", "Masha", "Vasya" и "Vasylysa" ;)' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" value="Поиск" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '</table>' . "\n";
		echo '</form>' . "\n";
	} else {
		$search = cut($_REQUEST['search'], 25);
		$search = preg_replace('/[^A-z0-9\-_%]+/', '', $search);
		$search = preg_replace('/_*%+_*/', '%', $search);
		
		if (substr_count($search, '%') < 3 && $search != '%') {
			$sql = 'select user_id, user_login, user_register, user_count_posts, user_count_comments 
			from ' . USERS_TABLE . ' where ' . (is_unsigned($search) ? 'user_id = ' . $search : 'user_login ' . (preg_match('/%|_/', $search) ? 'like' : '=') . ' "' . $search . '"');
			
			$query = mysql_query($sql);
			$count = mysql_num_rows($query);
			
			if ($count <= 1) {
				$search = '';
			}
			
			if ($count) {
				echo '<table ' . get_option('table_attributes') . '>' . "\n";
				echo '<tr>' . "\n";
				echo '<td id="title">' . "\n";
				echo 'Результаты поиска' . "\n";
				echo '</td>' . "\n";
				echo '</tr>' . "\n";
				
				while ($fields = mysql_fetch_assoc($query)) {
					echo '<tr>' . "\n";
					echo '<td id="text">' . "\n";
					echo '<a href="profile.php?user=' . $fields['user_id'] . '">' . $fields['user_login'] . '</a> ';
					
					switch (is_online($fields['user_id'])) {
						case USER_ONLINE:
							echo '<span id="online">[On]</span>';
							break;
						
						case USER_OFFLINE:
							echo '<span id="offline">[Off]</span>';
							break;
						
						case USER_HIDE:
							echo '<span id="hide">[Hid]</span>';
					}
					
					echo '<br />' . "\n";
					echo 'Дата регистрации: ' . fdate($fields['user_register']) . '<br />' . "\n";
					echo 'Всего записей: <a href="blogs/index.php?user=' . $fields['user_id'] . '&amp;all">' . $fields['user_count_posts'] . '</a><br />' . "\n";
					echo 'Всего комментариев: <a href="blogs/comments.php?user=' . $fields['user_id'] . '">' . $fields['user_count_comments'] . '</a>' . "\n";
					echo '</td>' . "\n";
					echo '</tr>' . "\n";
				}
				
				echo '</table>' . "\n";
				
				echo '<p>' . "\n";
				echo '<a href="users.php?search">К поиску</a>' . "\n";
				echo '</p>' . "\n";
			} else {
				$search = '';
				
				echo '<p>' . "\n";
				echo 'К сожалению поиск не принес результатов' . "\n";
				echo '</p>' . "\n";
			}
		} else {
			echo '<p>' . "\n";
			echo 'Ваш запрос слишком сложный, упростите его' . "\n";
			echo '</p>' . "\n";
		}
	}
} elseif (isset($_REQUEST['online'])) {
	/**
	 * Онлайн
	 */
	
	$theme = array (
		'Онлайн',
		'Онлайн',
		'<a href="users.php">Пользователи</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	
	$sql = 'select count(*) from ' . SESSIONS_TABLE;
	$count = mysql_result(mysql_query($sql), 0);
	
	$pagination = pagination_main($count, get_nav_posts());
	
	$sql = 'SELECT s.*, u.user_login, u.user_hide_online from ' . SESSIONS_TABLE . ' as s 
	left join ' . USERS_TABLE . ' as u using (user_id) 
	order by ' . $mode . ' ' . $order . ' 
	limit ' . $pagination['start'] . ', ' . $pagination['end'];
	
	$query = mysql_query($sql);
	
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Пользователи онлайн' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	while ($fields = mysql_fetch_assoc($query)) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		
		if (!$fields['user_id']) {
			echo 'Гость';
		} elseif ($fields['user_hide_online'] && !$is_admin) {
			echo 'Скрытый пользователь';
		} else {
			echo '<a href="profile.php?user=' . $fields['user_id'] . '">' . $fields['user_login'] . '</a>';
		}
		
		if ($fields['ip'] == IP) {
			echo ' (это Вы)';
		}
		
		echo '<br />' . "\n";
		
		if ($is_admin) {
			echo 'IP: ' . $fields['ip'] . '<br />' . "\n";
			echo 'UA: ' . $fields['ua'] . '<br />' . "\n";
		}
		
		/**
		 * Местоположение на сайте
		 * Хотелось сделать хранение данных о страницах в БД, но лень ;)
		 */
		switch ($fields['page']) {
			case 'friends.php':
				$where = 'Просматривает список друзей';
				break;
			
			case 'groups.php':
				$where = 'Просматривает список групп';
				break;
			
			case 'index.php':
				$where = 'На главной';
				break;
			
			case 'login.php':
				$where = 'Авторизуется';
				break;
			
			case 'privmsgs.php':
				$where = 'Просматривает личные сообщения';
				break;
			
			case 'profile.php':
				$where = 'Просмотривает профиль';
				break;
			
			case 'register.php':
				$where = 'Регистрируется';
				break;
			
			case 'settings.php':
				$where = 'Настраивает сайт';
				break;
			
			case 'usercp.php':
				$where = 'Управляет своим профилем';
				break;
			
			case 'users.php':
				$where = 'Просматривает списки пользователей';
				break;
			
			case 'wall.php':
				$where = 'Просматривает записи стены';
				break;
			
			
			case 'blogs/addpost.php':
				$where = 'Создает запись';
				break;
			
			case 'blogs/blogs.php':
				$where = 'Просматривает списки блогов';
				break;
			
			case 'blogs/comments.php':
				$where = 'Просматривает комментарии';
				break;
			
			case 'blogs/editpost.php':
				$where = 'Редактирует запись';
				break;
			
			case 'blogs/index.php':
				$where = 'Просматривает заголовки записей';
				break;
			
			case 'blogs/post.php':
				$where = 'Просматривает запись';
				break;
			
			case 'blogs/tag.php':
				$where = 'Ищет записи по метке';
				break;
			
			default:
				$where = substr($fields['page'], 0, 8) == 'wb-admin' ? 'Администирует сайт' : 'Неизвестно';
		}
		
		echo 'Где: <a href="' . $fields['page'] . '">' . $where . '</a><br />' . "\n";
		
		
		$time = time() - $fields['start_time'];
		
		if ($time < 60) {
			echo 'На сайте: Менее минуты';
		} elseif ($time < 3600 && $time > 60) {
			$minutes = $time / 60;
			$minutes = $minutes != ceil($minutes) ? ceil($minutes-1) : $minutes;
			
			echo 'На сайте: ';
			echo $minutes . ' ' . declension($minutes, array('минута', 'минуты', 'минут'));
		} elseif ($time >= 3600) {
			$hours = $time / 3600;
			$hours = $hours != ceil($hours) ? ceil($hours-1) : $hours;
			
			$minutes = ($time - 3600*$hours) / 60;
			$minutes = ($minutes != ceil($minutes) ? ceil($minutes-1) : $minutes);
			
			echo 'На сайте: ';
			echo $hours . ' ' . declension($hours, array('час', 'часа', 'часов'));
			echo $minutes ? ' ' . $minutes . ' ' . declension($minutes, array('минута', 'минуты', 'минут')) : '';
		}
		
		echo '<br />' . "\n";
		echo 'Переходов: ' . $fields['count_clicks'] . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '</table>';
	
	if ($pagination['all_pages'] > 1) {
		echo '<p>' . "\n";
		echo 'Всего пользователей: ' . $count . '<br />' . "\n";
		echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'users.php?online&amp;page=%d') . "\n";
		echo '</p>' . "\n";
	}
} elseif (isset($_REQUEST['users'])) {
	/**
	 * Все пользователи
	 */
	
	$theme = array (
		'Список пользователей',
		'Список пользователей',
		'<a href="users.php">Пользователи</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	$sql = 'select count(*) from ' . USERS_TABLE;
	$count = mysql_result(mysql_query($sql), 0);
	
	$pagination = pagination_main($count, get_nav_posts());
	
	$sql = 'select user_id, user_login, user_register, user_count_posts, user_count_comments 
	from ' . USERS_TABLE . ' order by ' . $mode . ' ' . $order . ' 
	limit ' . $pagination['start'] . ', ' . $pagination['end'];
	
	$query = mysql_query($sql);
	
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Список пользователей' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	while ($fields = mysql_fetch_assoc($query)) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo '<a href="profile.php?user=' . $fields['user_id'] . '">' . $fields['user_login'] . '</a> ';
		
		switch (is_online($fields['user_id'])) {
			case USER_ONLINE:
				echo '<span id="online">[On]</span>';
				break;
			
			case USER_OFFLINE:
				echo '<span id="offline">[Off]</span>';
				break;
			
			case USER_HIDE:
				echo '<span id="hide">[Hid]</span>';
		}
		
		echo '<br />' . "\n";
		echo 'Дата регистрации: ' . fdate($fields['user_register']) . '<br />' . "\n";
		echo 'Всего записей: <a href="blogs/index.php?user=' . $fields['user_id'] . '&amp;all">' . $fields['user_count_posts'] . '</a><br />' . "\n";
		echo 'Всего комментариев: <a href="blogs/comments.php?user=' . $fields['user_id'] . '">' . $fields['user_count_comments'] . '</a>' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '</table>' . "\n";
	
	if ($pagination['all_pages'] > 1) {
		echo '<p>' . "\n";
		echo 'Всего пользователей: ' . $count . '<br />' . "\n";
		echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'users.php?users&amp;page=%d') . "\n";
		echo '</p>' . "\n";
	}
} else {
	/**
	 * Index
	 */
	
	$theme = array (
		'Пользователи',
		'Пользователи',
		'<a href="index.php">На главную</a>'
	);
	
	$online = online_statistics();
	
	$sql = 'select count(*) from ' . USERS_TABLE;
	$count = mysql_result(mysql_query($sql), 0);
	
	echo '<p>' . "\n";
	echo '<a href="users.php?users">Пользователи (' . $count . ')</a><br />' . "\n";
	echo '<a href="users.php?online">Онлайн (' . $online['u'] . ')</a><br />' . "\n";
	echo '<a href="users.php?search">Поиск</a>' . "\n";
	echo '</p>' . "\n";
	
}

if (isset($_REQUEST['users']) || isset($_REQUEST['online']) || $search) {
	echo '<p>' . "\n";
	echo '<form action="users.php" method="post">' . "\n";
	echo isset($_REQUEST['users']) ? '<input type="hidden" name="users" />' . "\n" : '';
	echo isset($_REQUEST['online']) ? '<input type="hidden" name="online" />' . "\n" : '';
	echo $search ? '<input type="hidden" name="search" value="' . $search . '" />' . "\n" : '';
	echo 'Упорядочить по:<br />' . "\n";
	echo '<select name="mode">' . "\n";
	echo ' <option value="user_login"' . ($mode == 'user_login' ? ' selected="selected"' : '') . '>Логину</option>' . "\n";
	echo ' <option value="user_register"' . ($mode == 'user_register' ? ' selected="selected"' : '') . '>Регистрации</option>' . "\n";
	echo ' <option value="user_count_posts"' . ($mode == 'user_count_posts' ? ' selected="selected"' : '') . '>Количеству записей</option>' . "\n";
	echo ' <option value="user_count_comments"' . ($mode == 'user_count_comments' ? ' selected="selected"' : '') . '>Количеству комментариев</option>' . "\n";
	echo '</select>' . "\n";
	echo '<select name="order">' . "\n";
	echo ' <option value="asc"' . ($order == 'asc' ? ' selected="selected"' : '') . '>По возрастанию</option>' . "\n";
	echo ' <option value="desc"' . ($order == 'desc' ? ' selected="selected"' : '') . '>По убыванию</option>' . "\n";
	echo '</select><br />' . "\n";
	echo '<input type="submit" value="Применить" />' . "\n";
	echo '</form>' . "\n";
	echo '</p>' . "\n";
}

close($theme);
?>