<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
defined('IN_WBENGINE') or die('Hacking attempt');

/**
 * возвращает количество секунд, оставшихся до снятия антифлуда
 *
 * @return integer
 */
function antiflood() {
	global $user_data, $is_admin;
	
	/**
	 * В случае перевода времени на сервере назад 
	 * произойдет автоматическое обновление времени последнего сообщения во всех профилях
	 */
	
	if ($user_data['user_last_post_time'] > time()) {
		$last_post_time = $user_data['user_last_post_time'] = time() - 3600;
		
		$sql = 'update ' . USERS_TABLE . ' 
		set user_last_post_time = ' . $last_post_time . ' where user_last_post_time > ' . time();
		
		mysql_query($sql);
		return 0;
	}
	
	if ($is_admin) {
		return 0;
	}
	
	$wait = $user_data['user_last_post_time'] + get_option('flood_time') - time();
	return $wait > 0 ? $wait : 0;
}


/**
 * производит замену html-символов в мнемоники; удаляет quotes, символы табуляции,
 * NUL-байты (\0) и т.д. Без передачи второго аргумента (или передаче false) также
 * удаляет символы новой строки.
 *
 * @param string $string строка данных для обработки
 * @param boolean $enters
 * @return string
 */
function check($string, $enters = false) {
	$string = stripslashes(trim($string));
	$string = htmlentities($string, ENT_QUOTES, 'UTF-8');
	$string = str_replace(array('\t', '\0'), '', $string);
	
	if (!$enters) {
		$string = str_replace(array('\r', '\n'), '', $string);
	}
	
	return $string;
}

/**
 * получает буфер обмена, даннык для подстановки в тему; вставляет буффер и данные в
 * шаблон; вырезает img-тэги из сгенерированного html-кода страницы; определяет 
 * поддержку сжатых страниц в браузере и сжимает; передает страницу в браузер.
 *
 */
function close() {
	global $is_logged, $is_admin, $user_data;
	
	/**
	 * Получение аргументов:
	 * close(array(param1[, param2[, ...]]))
	 * close(param1[, param2[, ...]])
	 */
	$theme = func_get_args();
	$theme = isset($theme[0]) && is_array($theme[0]) ? $theme[0] : $theme;
	
	/**
	 * Получение буффера
	 */
	$buffer = ob_get_contents();
	ob_end_clean();
	
	/**
	 * Загрузка темы
	 */
	$ussed_theme = get_option('theme');

	if ($is_logged) { 
		if (!is_dir(HOME . 'wb-includes/themes/' . $user_data['user_theme'])) {
			/**
			 * Если тема удалена, обновляем user_theme в профилях пользователей на существующую тему
			 */
			$sql = 'update ' . USERS_TABLE . ' set user_theme = "' . $ussed_theme . '" 
			where user_theme = "' . $user_data['user_theme']  . '"';
			
			mysql_query($sql);
		} else {
			$ussed_theme = $user_data['user_theme'];
		}
	}
	
	// Старт буфера
	ob_start();
	
	// Модификация буфера файлом темы
	include(HOME . 'wb-includes/themes/' . $ussed_theme . '/theme.php');
	
	// Получение данных буфера, закрытие
	$buffer = ob_get_contents();
	ob_end_clean();
	
	
	/**
	 * ВЫрезка изображений из буффера
	 */
	if ($is_logged && !$user_data['user_allow_images']) {
		$buffer = preg_replace('|<img.*?(?<!(?:view="view"\s))/>|si', 'image', $buffer);
	}
	
	if (get_option('allow_compress')) {
		/**
		 * Определение поддерживаемых браузером вариантов сжатия.
		 * Сжимаем буффер, передаем соответствующий буффер.
		 */
		@$ae = $_SERVER['HTTP_ACCEPT_ENCODING'] ? $_SERVER['HTTP_ACCEPT_ENCODING'] : $_SERVER['HTTP_TE'];
		
		if (strstr('deflate', $ae)) {
			header('Content-Encoding: deflate');
			$buffer = gzdeflate($buffer);
		} elseif (strstr('gzip',$ae)) {
			header('Content-Encoding: gzip');
			$buffer = gzencode($buffer);
		} elseif (strstr('x-gzip', $ae)) {
			header('Content-Encoding: x_gzip');
			$buffer = gzcompress($buffer, 9);
		}
	}
	
	die($buffer);
}

/**
 * возвращает произвольную строку указанной длины, состоящую из символов A-z 0-9
 *
 * @param integer $lenght длина генерируемового ключа
 * @return string
 */
function create_id($lenght = 16) {
	$letters = array('Q','W','E','R','T','Y','U','I','O','P','A','S','D','F','G','H','J','K','L','Z','X','C','V','B','N','M','q','w','e','r','t','y','u','i','o','p','a','s','d','f','g','h','j','k','l','z','x','c','v','b','n','m','1','2','3','4','5','6','7','8','9','0');
	$id = '';
	
	for ($i = 0; $i < $lenght; $i++) {
		$id .= $letters[mt_rand(0, 61)];
	}
	
	return $id;
}

/**
 * возвращает timestamp, скорректированный в соотвествии со сдвигом часового пояса, 
 * указанным в настройках
 *
 * @return integer
 */
function ctime() {
	return (time() + $GLOBALS['config']['date_adjust']*3600);
}

/**
 * возвращает часть строки, от 0 до указанного символа
 *
 * @param string $string строка данных для обработки
 * @param integer $end 
 * @return string 
 */
function cut($string, $end) {
	return mb_substr($string, 0, (int) $end);
}

/**
 * cклонение русских слов после порядковых числительных
 * @autors Юрий Насретдинов, Дмитрий Кóтеров (dklab.ru)
 *
 * @param integer $int числительное
 * @param array $expressions варианты слов
 * @return string
 */
function declension($int, $expressions) {
	if (count($expressions) < 3) {
		$expressions[2] = $expressions[1];
	}
	
	$int = (int) $int;
	$count = $int % 100;
	
	if ($count >= 5 && $count <= 20) {
		$result = 2;
	} else {
		$count = $count % 10;
		
		if ($count == 1) {
			$result = 0;
		} elseif ($count >= 2 && $count <= 4) {
			$result = 1;
		} else {
			$result = 2; 
		}
	}
	
	return $expressions[$result];
}

/**
 * Удаление кода капчи
 *
 * @return boolean
 */
function delete_captcha_code() {
	unset($_SESSION["captcha_code"]);
	return true;
}

/*
 * возвращает формат времени, скорректированного в соотвествии со сдвигом часового 
 * пояса пользователя
 *
 * @param integer $time timestamp
 * @return 
 */
function fdate($time = 0) {
	global $is_logged, $user_data;
	$adjust = get_option('date_adjust') + ($is_logged ? $user_data['user_date_adjust'] : 0);
	$adjust *= 3600;
	
	return date(get_option('date_format'), (is_unsigned($time) ? $time : time()) + $adjust);
}

/**
 * возвращает размер файла, округленный до Мб/Кб
 *
 * @param integer $size размер файла в байтах
 * @return integer
 */
function fsize($size) {
	if ($size < 1024) {
		$result = round($size, 2) . ' B';
	} elseif ($size > 1024 && $size < 1048576) {
		$result = round(($size / 1024), 2) . ' Kb';
	} else {
		$result = round(($size / 1048576), 2) . ' Mb';
	}
	return $result;
}

/**
 * Получение кода капчи
 *
 * @return integer
 */
function get_captcha_code() {
	return isset($_SESSION["captcha_code"]) && preg_match('/^\d{5}$/', $_SESSION["captcha_code"]) ? $_SESSION["captcha_code"] : false;
}

/**
 * Получение опции из конфига
 *
 * @param string|integer $value значение
 * @return string
 */
function get_option($value = '') {
	static $config;
	
	if (!count($config)) {	
		/**
		 * Если массив не составлен, получаем данные из БД, создаем ассоциативный массив
		 */
		$sql = "select config_key, config_value from " . CONFIG_TABLE;
		$query = mysql_query($sql);
		
		while ($rows = mysql_fetch_row($query)) {
			$config[$rows[0]] = $rows[1];
		}
		$config['tags_glue'] = ', ';
	}
	
	return ($value ? (isset($config[$value]) ? $config[$value] : false) : $config);
}

/**
 * Получение числа комментариев на страницу
 *
 * @return integer
 */
function get_nav_comments() {
	$int = (int) ($GLOBALS["is_logged"] ? $GLOBALS["user_data"]["user_nav_comments"] : get_option("nav_comments"));
	return $int >= 1 ? $int : 1;
}

/**
 * Получение числа постов на страницу
 *
 * @return integer
 */
function get_nav_posts() {
	$int = (int) ($GLOBALS["is_logged"] ? $GLOBALS["user_data"]["user_nav_posts"] : get_option("nav_posts"));
	return $int >= 1 ? $int : 1;
}

/**
 * Получение массива существующих тем
 *
 * @return integer
 */
function get_themes() {
	$themes = array();
	$dir = opendir(HOME . 'wb-includes/themes');
	
	while ($object = readdir($dir)) {
		if ($object != '.' && $object != '..' && is_dir(HOME . 'wb-includes/themes/' . $object)) {
			$themes[] = $object;
		}
	}
	
	closedir($dir);
	return $themes;
}
 

/**
 * возвращает прошедших количество секунд
 *
 * @param array $time timestamp с микросекундами
 * @param integer $precision количество цифр после десятичной точки
 * @return float
 */
function gtime($time = TIME, $precision = 4) {
	return round((array_sum(explode(' ', microtime())) - array_sum(explode(' ', $time))), (int) $precision);
}

/**
 * возвращает online-статус пользователя
 *
 * Константы:
 * USER_ONLINE - онлайн
 * USER_OFFLINE - оффлайн
 * USER_HIDE - скрытый
 *
 * @param integer $user_id id пользователя
 * @param boolean $refresh обновить кэш статистики
 * @return integer
 */

function is_online($user_id, $refresh = false) {
	static $arrays = array(array(), array());
	static $check = true;
	
	if ($check || $refresh) {
		global $is_admin;
		$check = false;
		
		if ($is_admin) {
			$sql = 'select user_id 
			from ' . SESSIONS_TABLE . ' where user_id <> 0';
		} else {
			$sql = 'SELECT s.user_id, u.user_hide_online 
			from ' . SESSIONS_TABLE . ' as s 
			inner join ' . USERS_TABLE . ' as u using (user_id) 
			where s.user_id <> 0';
		}
		
		$query = mysql_query($sql);
		
		while ($rows = mysql_fetch_row($query)) {
			$arrays[$is_admin ? 0 : ($rows[1] ? 1 : 0)][] = $rows[0];
		}
	}
	
	if (in_array($user_id, $arrays[0])) {
		return USER_ONLINE;
	} elseif (in_array($user_id, $arrays[1])) {
		return USER_HIDE;
	} else {
		return USER_OFFLINE;
	}
}

/**
 * определяет, является ли переменная не отрицательным целым числом или 
 * числовой строкой
 * 
 * @param integer $int число
 * @param boolean $more_null число должно быть положительным, если true
 * @return boolean
 */
function is_unsigned($int, $more_null = false) {
	return (preg_match('/^\d+$/', $int) && $int >= 0 && (!$more_null || $int > 0));
}

/**
 * возвращает массив с онлайн-данными, массивом онлайн-пользователями (id, login)
 *
 * @param $refresh обновление
 * @return array
 */
function online_statistics($refresh = false) {
	static $array = array('g' => 0, 'u' => 0, 'a' => 0, 'users' => array());
	static $check = true;
	
	if ($check || $refresh) {
		$array = array('g' => 0, 'u' => 0, 'a' => 0);
		$check = false;
		
		$sql = 'select s.user_id, u.user_login
		from ' . SESSIONS_TABLE . ' as s 
		left join ' . USERS_TABLE . ' as u using (user_id)';
		
		$query = mysql_query($sql);
		
		while (list($id, $login) = mysql_fetch_row($query)) {
			$array[$id == 0 ? 'g' : 'u']++;
			$array['a']++;
			
			if ($login) {
				$array['users'][] = array (
					'id' => $id,
					'login' => $login
				);
			}
		}
	}
	
	return $array;
}

/**
 * возвращает ассоциативный массив с посчитанными значениями для выборки sql и
 * другими аргументами. $page передавать необязательно
 *
 * @param integer $count - всего элементов
 * @param integer $on_page - количество элементов на страницу
 * @param integer $page - текущая страница
 * @return array
 */
function pagination_main($count, $on_page, $page = 1) {
	$all_pages = ceil($count / $on_page);
	
	$page = isset($GLOBALS['_REQUEST']['page']) ? $GLOBALS['_REQUEST']['page'] : $page;
	$page = is_unsigned($page, true) ? $page : 1;
	$page = $page > $all_pages ? $all_pages : $page;
	
	return array('all_pages' => $all_pages, 'page' => $page, 'start' => (($page - 1) * $on_page), 'end' => $on_page);
}

/**
 * возвращает список ссылок для навигации по страницам
 *
 * @param integer $all_pages всего страниц
 * @param integer $page текущая страница
 * @param string $url строка для sprinf
 * @return string
 */
function pagination_links($all_pages, $page, $url = '') {
	$result = '';
	
	if ($all_pages > 1 && ($page > 0 && $page <= $all_pages)) {
		if ($page > 1) {
			$result .= '<a href="' . sprintf($url, ($page - 1)) . '">Пред.</a> ';
		}
		
		for ($i = 1; $i <= 2; $i++) {
			if ($i < $page - 2) {
				$result .= '<a href="' . sprintf($url, $i) . '">' . $i . '</a>';
				$result .= ($i == 2 && $page > 5) ? ' ... ' : ', ';
			} else {
				break;
			}
		}
		
		for ($i = $page - 2; $i <= $page + 2; $i++) {
			if ($i > 0 && $i <= $all_pages) {
				$result .= $i == $page ? $page : '<a href="' . sprintf($url, $i) . '">' . $i . '</a>';
				$result .= $i == $all_pages ? '' : ($i == $page + 2 && $i < $all_pages - 2 ? ' ... ' : ', ');
			}
		}
		
		for ($i = $all_pages - 1; $i <= $all_pages; $i++) {
			if ($i >= $page + 3) {
				$result .= '<a href="' . sprintf($url, $i) . '">' . $i . '</a>';
				$result .= $i == $all_pages ? $page == $all_pages ? '' : ' ' : ', ';
			}
		}
		
		if ($page < $all_pages) {
			$result .= ' <a href="' . sprintf($url, ($page + 1)) . '">След.</a>';
		}
	}
	
	return $result;
}

/**
 * загружает необходимые библиотеки функций
 * можно передавать массив значений или неограниченное количество значений
 *
 * @param array(string[, string[, string])|string[, string[, string]] файлы для загрузки
 */
function plugins() {
	$plugins = func_get_args();
	$plugins = isset($plugins[0]) && is_array($plugins[0]) ? $plugins[0] : $plugins;
	
	foreach ($plugins as $name) {
		if (is_string($name) && preg_match('/^[A-z0-9\-_]+$/', $name) && is_file(HOME . 'wb-includes/plugins/' . $name)) {
			include_once (HOME . 'wb-includes/plugins/' . $name);
		}
	}
}

/**
 * отправляет header с редиректом, очищает буффер, закрывает обработку страницы
 *
 * @param string $url - УРЛ
 */
function redirect($url) {
	ob_clean();
	header(preg_match('/microsoft|webstar|xitami/i', getenv('SERVER_SOFTWARE')) ? 'Refresh: 0; URL=' : 'Location: ' . $url);
	exit;
}

/**
 * Отсылает форматированное сообщение каждому из списка получаталей
 *
 * @param string|array $emails email получателя(ей)
 * @param string $email_from email отправителя
 * @param string $subject сабж
 * @param string $message сообщение
 */
function send_mail($emails, $email_from, $subject, $message) {
	$emails = is_array($emails) ? $emails : array($emails);
	
	$headers = 'From: Administrator <' . $email_from . '>' . "\n"
				. 'Reply-To: ' . $email_from . "n"
				. 'Subject: ' . $subject . "\n"
				. 'X-Mailer: PHP/' . phpversion() . ', WBE/' . WB_ENGINE_VERSION  ."\n"
				. 'Content-Transfer-Encoding: 8bit' . "\n"
				. 'Content-Type: text/plain; charset=' . get_option('email_charset') . "\n";
	
	foreach($emails as $email) {
		if (preg_match('/^[\.A-z0-9_\-]+[@][A-z0-9_\-]+([.][A-z0-9_\-]+)+[A-z]{1,4}$/', $email)) {
			mail($email, $subject, $message, $headers);
		}
	}
}

/**
 * Устанавливает значение переменной в конфиге
 * 
 * @param string $key Ключ
 * @param string|integer $value Значение
 * @return boolean
 */
function set_option($key, $value) {
	$sql = "update " . CONFIG_TABLE . " set config_value = " . mysql_escape_string($value) . " 
	where config_key = " . mysql_escape_string($key);
	
	mysql_query($sql);
	return (bool) mysql_affected_rows();
}

/**
 * возвращает строку с замененными bb-кодами на html-тэги
 *
 * @param string $string строка
 * @return string
 */
function tags($string) {
	$string = nl2br($string);
	$string = preg_replace('/\[b\](.*?)\[\/b\]/si', '<span style="font-weight:bold;">\1</span>', $string);
	$string = preg_replace('/\[i\](.*?)\[\/i\]/si', '<span style="font-style:italic;">\1</span>', $string);
	$string = preg_replace('/\[u\](.*?)\[\/u\]/si', '<span style="text-decoration:underline;">\1</span>', $string);
	$string = preg_replace('/\[red\](.*?)\[\/red\]/si', '<span style="color:red">\1</span>', $string);
	$string = preg_replace('/\[green\](.*?)\[\/green\]/si', '<span style="color:green">\1</span>', $string);
	$string = preg_replace('/\[blue\](.*?)\[\/blue\]/si', '<span style="color:blue">\1</span>', $string);
	$string = preg_replace('/\[q\](.*?)\[\/q\]/si', '<span id="quote">\1</span>', $string);
	$string = preg_replace('/\[color=([0-9a-f]{6})\](.*?)\[\/color\]/si', '<span style="color:#\1">\2</span>', $string);
	$string = preg_replace('/\[url\=(.*?)\](.*?)\[\/url\]/si', '<a href="\1">\2</a>', $string);
	return $string;
}

/**
 * возвращает строку с замененными английскими буквами на русские
 *
 * @param string $string строка
 * @param boolean $flip развернуть массив для обратной транслитизации
 * @return string
 */
function translit($string, $flip = false) {
	$array = array('a' => 'а', 'b' => 'б', 'v' => 'в', 'g' => 'г', 'd' => 'д', 'e' => 'е', 'yo' => 'ё', 'zh' => 'ж', 'z' => 'з', 'i' => 'и', 'j' => 'й', 'k' => 'к', 'l' => 'л', 'm' => 'м', 'n' => 'н', 'o' => 'о', 'p' => 'п', 'r' => 'р', 's' => 'с', 't' => 'т', 'u' => 'у', 'f' => 'ф', 'h' => 'х', 'c' => 'ц', 'ch' => 'ч', 'sh' => 'ш', 'sch' => 'щ', 'q' => 'ъ', 'y' => 'ы', 'x' => 'э', 'yu' => 'ю', 'ya' => 'я', 'A' => 'А', 'B' => 'Б', 'V' => 'В', 'G' => 'Г', 'D' => 'Д', 'E' => 'Е', 'YO' => 'Ё', 'Yo' => 'Ё', 'ZH' => 'Ж', 'Zh' => 'Ж', 'Z' => 'З', 'I' => 'И', 'J' => 'Й', 'K' => 'К', 'L' => 'Л', 'M' => 'М', 'N' => 'Н', 'O' => 'О', 'P' => 'П', 'R' => 'Р', 'S' => 'С', 'T' => 'Т', 'U' => 'У', 'F' => 'Ф', 'H' => 'Х', 'C' => 'Ц', 'CH' => 'Ч', 'Ch' => 'Ч', 'SH' => 'Ш', 'Sh' => 'Ш', 'SCH' => 'Щ', 'Sch' => 'Щ', 'Q' => 'Ъ', 'Y' => 'Ы', 'X' => 'Э', 'YU' => 'Ю', 'Yu' => 'Ю', 'YA' => 'Я', 'Ya' => 'Я');
	return strtr($string, ($flip ? array_flip($array) : $array));
}


/**
 * возвращает строку с вырезанными bb-кодами
 *
 * @param string $string строка
 * @return string
 */
function untags($string) {
	$string = preg_replace('/\[b\](.*?)\[\/b\]/si', '\1', $string);
	$string = preg_replace('/\[i\](.*?)\[\/i\]/si', '\1', $string);
	$string = preg_replace('/\[u\](.*?)\[\/u\]/si', '\1', $string);
	$string = preg_replace('/\[url\=(.*?)\](.*?)\[\/url\]/si', '\1', $string);
	$string = preg_replace('/\[red\](.*?)\[\/red\]/si', '\1', $string);
	$string = preg_replace('/\[green\](.*?)\[\/green\]/si', '\1', $string);
	$string = preg_replace('/\[blue\](.*?)\[\/blue\]/si', '\1', $string);
	$string = preg_replace('/\[q\](.*?)\[\/q\]/si', '\1', $string);
	return $string;
}

/**
 * обновляет timestamp последнего сообщения пользователя
 *
 */
function update_antiflood() {
	if ($GLOBALS["is_admin"]) {
		return;
	}
	
	$GLOBALS["user_data"]['user_last_post_time'] = time();
	
	$sql = 'update ' . USERS_TABLE . ' 
	set user_last_post_time = ' . time() . ' where user_id = ' . $GLOBALS["user_id"];
	
	mysql_query($sql);
}

/**
 * обновляет счетчик новых сообщений в профиле указанного пользователя
 *
 * @param string $user_id id пользователя
 */
function update_unread_privmsgs($user_id) {
	$query = mysql_query('select count(*) from ' . PRIVMSGS_IN_TABLE  . ' 
	where privmsgs_user_id = ' . $user_id . ' and privmsgs_read = "0"');
	
	$count = mysql_result($query, 0);
	
	mysql_query('update ' . USERS_TABLE . ' 
	set user_unread_privmsgs = ' . $count . '	where user_id = ' . $user_id);
	
	/**
	 * "Моментальное отображение"
	 * Прочтение полученного сообщения на этой же странице уменьшит счетчик новых сообщений
	 */
	if ($user_id == $GLOBALS['user_id']) {
		$GLOBALS['user_data']['user_unread_privmsgs'] = $count;
	}
}
?>