<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
defined('IN_WBENGINE') or die('Hacking attempt');

/**
 * Возвращает true, если пользователь является членом блога
 *
 * @param integer $blog_id Id блога
 * @param integer $user_id Id пользователя
 * @return boolean
 */
function is_blog_user($blog_id, $user_id) {
	if (!is_unsigned($blog_id, true) || !is_unsigned($user_id, true)) {
		return false;
	}
	
	$query = mysql_query('select count(*) from ' . BLOGS_USER_TABLE . ' 
	where blog_id = ' . $blog_id . ' and user_id = ' . $user_id . ' and is_entry = "0"');
	
	return (bool) mysql_result($query, 0);
}

/**
 * Получение полномочий пользователя в коллективном блоге
 *
 * @param integer $blog_id Id блога
 * @param array|string $params параметр(ы) для возврата
 * @return array
 */
function get_blogs_access($blog_id, $params = null) {
	$allow_params = array('edit_post', 'delete_post', 'approve_user', 'delete_user', 'edit_comment', 'delete_comment');
	
	if ($params === null) {
		$params = $allow_params;
	}
	
	/**
	 * Проверка переданных параметров
	 */
	if (is_array($params)) {
		$params = array_unique($params);
		
		if (!count($params)) {
			return false;
		}
		
		foreach ($params as $param) {
			if (!in_array($param, $allow_params)) {
				return false;
			}
		}
		
		/**
		 * Формирование дефолтового возвращаемового массива
		 * Переменная is_admin, тип - boolean
		 */
		foreach ($params as $param) {
			$access[$param] = (bool) $GLOBALS['is_admin'];
		}
		
		if ($GLOBALS['is_admin'] || !$GLOBALS['is_logged']) {
			return $access;
		}
		
		/**
		 * Проход по циклу, проверка _указанных_ полномочий каждой группы,
		 * в которой участвует пользователь, занесение положительных результатов
		 */
		$sql = 'select a.* from ' . BLOGS_ACCESS_TABLE . ' as a 
		inner join ' . GROUP_USER_TABLE . ' as g on (g.group_id = a.group_id and g.user_id = ' . $GLOBALS['user_id'] . ') 
		where a.blog_id = ' . $blog_id;
		
		$query = mysql_query($sql);
		
		while ($fields = mysql_fetch_assoc($query)) {
			foreach ($params as $param) {
				if ($fields['allow_' . $param]) {
					$access[$param] = true;
				}
			}
		}
		
		/**
		 * Added by zick <24/07/2009 23:15>
		 */
		$sql = 'select * from ' . BLOGS_ACCESS_TABLE . ' as a 
		where blog_id = ' . $blog_id . ' and user_id = ' . $GLOBALS['user_id'];
		
		$query = mysql_query($sql);
		
		while ($fields = mysql_fetch_assoc($query)) {
			foreach ($params as $param) {
				if ($fields['allow_' . $param]) {
					$access[$param] = true;
				}
			}
		}
	} elseif (in_array($params, $allow_params)) {
		/**
		 * Передан один параметр
		 */
		$access[$params] = (bool) $GLOBALS['is_admin'];
		
		if ($GLOBALS['is_admin'] || !$GLOBALS['is_logged']) {
			return $access;
		}
		
		/**
		 * Проверка _одного_ полномочия, можно указать в sql-запросе
		 */
		$sql = 'select count(a.group_id) from ' . BLOGS_ACCESS_TABLE . ' as a 
		inner join ' . GROUP_USER_TABLE . ' as g on (g.group_id = a.group_id and g.user_id = ' . $GLOBALS['user_id'] . ') 
		where a.blog_id = ' . $blog_id . ' and a.allow_' . $params . ' = "1"';
		
		if (mysql_result(mysql_query($sql), 0)) {
			$access[$params] = true;
			return $access;
		}
		
		/**
		 * Added by zick <24/07/2009 23:17>
		 */
		$sql = 'select count(*) from ' . BLOGS_ACCESS_TABLE . ' 
		where blog_id = ' . $blog_id . ' and user_id = ' . $GLOBALS['user_id'] . ' and allow_' . $params . ' = "1"';
		
		$query = mysql_query($sql);
		
		if (mysql_result(mysql_query($sql), 0)) {
			$access[$params] = true;
		}
	} else {
		return false;
	}
	
	return $access;
}

/**
 * Получение полномочий пользователя к личным блогам пользователей
 *
 * @param array|string $params параметр(ы) для возврата
 * @return array
 */
function get_blog_access($params = NULL) {
	$allow_params = array('view_post', 'edit_post', 'delete_post', 'view_comments', 'edit_comment', 'hide_comment', 'delete_comment', 'comment');
	
	if ($params === NULL) {
		$params = $allow_params;
	}
	
	/**
	 * Проверка переданных параметров
	 */
	if (is_array($params)) {
		$params = array_unique($params);
		
		if (!count($params)) {
			return false;
		}
		
		foreach ($params as $param) {
			if (!in_array($param, $allow_params)) {
				return false;
			}
		}
		
		/**
		 * Формирование дефолтового возвращаемового массива
		 */
		foreach ($params as $param) {
			$access[$param]=false;// (boolean) $GLOBALS['is_admin'];
		}
		
		if ($GLOBALS['is_admin'] || !$GLOBALS['is_logged']) {
			return $access;
		}
		
		/**
		 * Проход по циклу, проверка _указанных_ полномочий каждой группы,
		 * в которой участвует пользователь, занесение положительных результатов
		 */
		$sql = 'select a.* from ' . BLOG_ACCESS_TABLE . ' as a 
		inner join ' . GROUP_USER_TABLE . ' as g using (group_id) 
		where g.user_id = ' . $GLOBALS['user_id'];
		
		$query = mysql_query($sql);
		
		while ($fields = mysql_fetch_assoc($query)) {
			foreach ($params as $param) {
				if ($fields['allow_' . $param]) {
					$access[$param] = true;
				}
			}
		}
		
		/**
		 * Added by zick <24/07/2009 23:22>
		 */
		$sql = 'select * 
		from ' . BLOG_ACCESS_TABLE . ' 
		where user_id = ' . $GLOBALS['user_id'];
		
		$query = mysql_query($sql);
		
		while ($fields = mysql_fetch_assoc($query)) {
			foreach ($params as $param) {
				if ($fields['allow_' . $param]) {
					$access[$param] = true;
				}
			}
		}
	} elseif (in_array($params, $allow_params)) {
		/**
		 * Передан один параметр
		 */
		$access[$params] = (boolean) $GLOBALS['is_admin'];
		
		if ($GLOBALS['is_admin'] || !$GLOBALS['is_logged']) {
			return $access;
		}
		
		/**
		 * Проверка _одного_ полномочия, можно указать в sql-запросе
		 */
		$sql = 'select count(a.group_id) from ' . BLOG_ACCESS_TABLE . ' as a 
		inner join ' . GROUP_USER_TABLE . ' as g on (g.group_id = a.group_id and g.user_id = ' . $GLOBALS['user_id'] . ') 
		where a.allow_' . $params . ' = "1"';
		
		if (mysql_result(mysql_query($sql), 0)) {
			$access[$params] = true;
			return $access;
		}
		
		/**
		 * Added by zick <24/07/2009 23:22>
		 */
		$sql = 'select count(*)
		from ' . BLOG_ACCESS_TABLE . ' 
		where user_id = ' . $GLOBALS['user_id'] . ' and allow_' . $params . ' = "1"';
		
		if (mysql_result(mysql_query($sql), 0)) {
			$access[$params] = true;
		}
	} else {
		return false;
	}
	
	return $access;
}

/**
 * Получение массива меток записи
 *
 * @param integer $post_id Id записи
 * @param string $link Ссылка на поиск по метке
 * @param string $glue Разделитель
 * @return array
 */
function get_post_tags($post_id, $link = '', $glue = '') {
	if (!is_unsigned($post_id, true)) {
		return false;
	}
	
	$sql = 'select post_tag from ' . BLOG_TAGS_TABLE . ' 
	where post_id = ' . $post_id;
	
	$tags = array();
	$query = mysql_query($sql);
	
	/** 
	 * Если на выходе нужно получить строку с перечислением ссылкок на поиск по меткам, 
	 * формируем массив, состоящий из ссылок (для последующего склеивания в строку)
	 */
	while (list($tag) = mysql_fetch_row($query)) {
		$tags[] = $link ? sprintf($link, urlencode($tag), $tag) : $tag;
	}
	
	/**
	 * Склеивание в строку
	 */
	if ($link) {
		$tags = implode($glue, $tags);
	}
	
	return $tags;
}

/**
 * Обновление счетчика читателей в блоге
 *
 * @param integer $blog_id Id блога
 * @return boolean
 */
function update_blog_count_users($blog_id) {
	if (!is_unsigned($blog_id, true)) {
		return false;
	}
	
	mysql_query('update ' . BLOGS_TABLE . ' set blog_count_users = (
	select count(*) from ' . BLOGS_USER_TABLE . ' where blog_id = ' . $blog_id . ' and is_entry = "0")
	where blog_id = ' . $blog_id);
	
	return (bool) mysql_affected_rows();
}

/**
 * Обновление счетчика комментариев к записи в блоге
 *
 * @param integer $post_id Id поста
 * @return boolean
 */
function update_post_count_comments($post_id) {
	if (!is_unsigned($post_id, true)) {
		return false;
	}
	
	mysql_query('update ' . BLOG_POSTS_TABLE . ' set post_count_comments = (
	select count(*) from ' . BLOG_COMMENTS_TABLE . ' where post_id = ' . $post_id . ') 
	where post_id = ' . $post_id);
	
	return (bool) mysql_affected_rows();
}

/**
 * Обновляет метки поста
 *
 * @param integer Id поста
 * @param mixed Аргументы
 * @return boolean
 */
function update_post_tags($post_id) {
	if (!is_unsigned($post_id, true)) {
		return false;
	}
	
	$tags = array_slice(func_get_args(), 1);
	$tags = isset($tags[0]) && is_array($tags[0]) ? $tags[0]: $tags;
	
	mysql_query('delete from ' . BLOG_TAGS_TABLE . ' where post_id = ' . $post_id);
	mysql_query('update ' . BLOG_POSTS_TABLE . ' set post_tags = "' . implode(', ', $tags) . '" where post_id = ' . $post_id);
	
	insert_post_tags($post_id, $tags);
	return true;
}

/**
 * Вставляет метки поста
 *
 * @param integer Id поста
 * @param mixed Аргументы
 * @return boolean
 */
function insert_post_tags($post_id) {
	if (!is_unsigned($post_id, true)) {
		return false;
	}
	
	$tags = array_slice(func_get_args(), 1);
	$tags = isset($tags[0]) && is_array($tags[0]) ? $tags[0]: $tags;
	
	foreach ($tags as $tag) {
		mysql_query('insert into ' . BLOG_TAGS_TABLE . ' values (' . $post_id . ', "' . $tag . '")');
	}
	
	return true;
}

/**
 * Обновление счетчика постов пользователя
 *
 * @param integer $user_id Id пользрователя
 * @return boolean
 */
function update_user_count_posts($user_id) {
	if (!is_unsigned($user_id, true)) {
		return false;
	}
	
	mysql_query('update ' . USERS_TABLE . ' set user_count_posts = (
	select count(*) from ' . BLOG_POSTS_TABLE . ' where user_id = ' . $user_id . ') 
	where user_id = ' . $user_id);
	
	return (bool) mysql_affected_rows();
}

/**
 * Обновление счетчика комментариев пользователя
 *
 * @param integer $user_id Id пользрователя
 * @return boolean
 */
function update_user_count_comments($user_id) {
	if (!is_unsigned($user_id, true)) {
		return false;
	}
	
	mysql_query('update ' . USERS_TABLE . ' set user_count_comments = (
	select count(*) from ' . BLOG_COMMENTS_TABLE . ' where user_id = ' . $user_id . ') 
	where user_id = ' . $user_id);
	
	return (bool) mysql_affected_rows();
}

/**
 * Получение форматированной строки популярных меток (с кешированием)
 *
 * @param integer $limit количество меток
 * @param boolean $shuffle разбросать
 * @param integer $min_size минимальный размер шрифта
 * @param integer $max_size максимальный размер шрифта
 * @return array
 */
function get_popular_tags($limit = 20, $shuffle = true, $min_size = 10, $max_size = 17) {
	if (!is_unsigned($limit, true) || !is_unsigned($max_size, true) || !is_unsigned($min_size, true)) {
		return array();
	}
	
	$tags = array();
	
	$query = mysql_query('select count(*) as count, post_tag as tag 
	from ' . BLOG_TAGS_TABLE . ' group by post_tag ' . ($shuffle ? '' : 'order by count desc ') . 'limit ' . $limit);
	
	while ($rows = mysql_fetch_assoc($query)) {
		$tags[] = $rows;
	}
	
	$min = 10000;
	$max = 0;
	
	foreach ($tags as $tag) {
		if ($max < $tag['count']) {
			$max = $tag['count'];
		}
		
		if ($min > $tag['count']) {
			$min = $tag['count'];
		}
	}
	
	$min_count = log($min + 1);
	$max_count = log($max + 1);
	
	$size_range = $max_size - $min_size;
	$count_range = $max_count - $min_count;
	$count_range = $count_range ? $count_range : 1;
	$ratio = $size_range / $count_range;
	
	foreach ($tags as & $tag) {
		$tag['size'] = round($min_size + (log($tag['count'] + 1) - $min_count) * $ratio);
	}
	
	if ($shuffle) {
		shuffle($tags);
	}
	
	return $tags;
}
?>