<?php
define('INSTALL_VERSION', '1.0c');

header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Cache-Control: no-cache, must-revalidate');
header('Pragma: no-cache');
header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . 'GMT');
header('Content-type: text/html; charset=UTF-8');

/**
 * Возвращает массив состоящий из sql-запросов
 * 
 * @author Касьянов Олег aka AlkatraZ
 * @param string $sql тело sql-запросов
 * @return array
 */
function split_sql($sql) {
	$sql = trim($sql);
	
	$buffer = array();
	$ret = array();
	$in_string = false;
	
	for ($i = 0; $i < strlen($sql) - 1; $i++) {
		if ($sql[$i] == ';' && !$in_string) {
			$ret[] = substr($sql, 0, $i);
			$sql = substr($sql, $i + 1);
			$i = 0;
		}
		
		if ($in_string && ($sql[$i] == $in_string) && $buffer[1] != '\\') {
			$in_string = false;
		} elseif (!$in_string && ($sql[$i] == '"' || $sql[$i] == "'") && (!isset($buffer[0]) || $buffer[0] != "\\")) {
			$in_string = $sql[$i];
		}
		
		if (isset($buffer[1])) {
			$buffer[0] = $buffer[1];
		}
		$buffer[1] = $sql[$i];
	}
	
	if (!empty($sql)) {
		$ret[] = trim($sql);
	}
	
	return $ret;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ru" lang="ru">
<head>
<title>Установка Wap Blogs Engine <?php echo INSTALL_VERSION ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<style type="text/css">
body {
  font: 14px "Trebuchet MS", verdana, arial, sans-serif black;
  color: #333;
  background: #FFF;
  margin: 0px;
  padding: 0px;
}

input, select, textarea {
 margin: 1px;
}

a {
 color: #1CA2DE;
 text-decoration: none;
}

a:hover {
 color: #83C21F;
}

div{
 padding: 4px;
 margin: 0px;
}

form {
 padding: 0px;
 margin: 0px;
}

#wbe {
 padding: 3px;
}

#link {
 float: right;
 padding: 3px;
 color: #FFF;
}

#link:hover {
 background: #CFF690;
 color: #83C21F;
}

#head {
 border-bottom: 4px solid #A2D157;
 margin-bottom: 6px;
 
 background: #83C21F;
 color: #FFF;
 
 height: 25px;
 
 padding-left: 8px;
 padding-top: 10px;
}

#foot {
 border-top: 4px solid #A2D157;
 margin-top: 6px;
 padding-left: 8px;
 
 background: #83C21F;
 font-size: 13px;
 color: white;
}

#content {
 padding: 5px;
}

#block {
 border: 0px solid #DDF1FF;
 background: #F1F9FF;
 padding: 4px;
 margin: 3px;
}

#title {
 padding: 6px;
 padding-bottom: 1px;
 border-bottom: 1px dotted #ADD3FF;
 color: #1CA2DE;
}

#title a:link, #title a:active, #title a:visited{
 background: #1CA2DE;
 color: #FFF;
 text-decoration: none;
 padding-left: 2px;
 padding-right: 2px;
}

#title a:hover {
 background: #BBDFFF;
 color: #1CA2DE;
 text-decoration: none;
}

#text {
 padding: 6px;
}

#info {
 font-size: 12px;
}
</style>
</head>
<body>
<div id="head">
<span id="wbe">Установка Wap Blogs Engine <?php echo INSTALL_VERSION ?></span>
<a href="../index.php" id="link">На главную</a> 
</div>
<div id="content">
<?php if (isset($_POST['install'])) {
	do {
		$connect = @mysql_connect($_POST['db_host'], $_POST['db_user'], $_POST['db_password']);
		
		if (!$connect || !@mysql_select_db($_POST['db_name'])) { ?>
<div id="block">
<div id="title">Параметры подключения к БД MySQL неверны</div>
<div id="text"><a href="index.php?enter">Ввести заново</a></div>
</div>
<?php
			break;
		}
		
		mysql_query('SET NAMES utf8', $connect);
		
		if (empty($_POST['user_login'])) { ?>
<div id="block">
<div id="title">Не указан логин пользователя</div>
<div id="text"><a href="index.php?enter">Ввести заново</a></div>
</div>
<?php
			break;
		}
		
		if (empty($_POST['user_email'])) { ?>
<div id="block">
<div id="title">Не указан email пользователя</div>
<div id="text"><a href="index.php?enter">Ввести заново</a></div>
</div>
<?php
			break;
		}
		
		if (!preg_match('/^[A-z0-9\-_]+$/', $_POST['user_login'])) { ?>
<div id="block">
<div id="title">В логине недопустимые символы</div>
<div id="text"><a href="index.php?enter">Ввести заново</a></div>
</div>
<?php
			break;
		}
		
		if (preg_match('/^\d+$/', $_POST['user_login'])) { ?>
<div id="block">
<div id="title">Логин не может быть числом</div>
<div id="text"><a href="index.php?enter">Ввести заново</a></div>
</div>
<?php
			break;
		}
		
		if (empty($_POST['user_password'])) { ?>
<div id="block">
<div id="title">Не указан пароль пользователя</div>
<div id="text"><a href="index.php?enter">Ввести заново</a></div>
</div>
<?php
			break;
		}
		
		if (!preg_match('/^[\.A-z\d_\-]+[@][A-z\d_\-]+([.][A-z\d_\-]+)+[A-z]{1,4}$/', $_POST['user_email'])) { ?>
<div id="block">
<div id="title">Неверный формат e-mail</div>
<div id="text"><a href="index.php?enter">Ввести заново</a></div>
</div>
<?php
			break;
		}
		
		if (!preg_match('/^[A-z0-9]+$/', $_POST['user_password'])) { ?>
<div id="block">
<div id="title">В пароле недопустимые символы</div>
<div id="text"><a href="index.php?enter">Ввести заново</a></div>
</div>
<?php
			break;
		}
		
		// Создание db.php
		if (($file = fopen('../wb-includes/db.php', 'w'))) {
			$text = '<?php
defined("IN_WBENGINE") or die("Hacking attempt");
$db_host = "%s";
$db_user = "%s";
$db_pass = "%s";
$db_name = "%s";

if (!($connect = mysql_connect($db_host, $db_user, $db_pass))) {
	die("Cannot connect to server");
}

if (!mysql_select_db($db_name)) {
	die("Cannot connect to db");
}

mysql_query("SET NAMES utf8", $connect);
unset($db_host, $db_user, $db_pass,$db_name);
?>';
			$text = sprintf($text, $_POST['db_host'], $_POST['db_user'], $_POST['db_password'], $_POST['db_name']);
			fwrite($file, $text);
			fclose($file);
		} else { ?>
<div id="block">
<div id="title">Установка не может быть продолжена</div>
<div id="text">Нет доступа к записи файла wb-includes/db.php</div>
</div>
		<?php }
		
		// Создание таблиц
		$sql = file_get_contents('install.sql');
		$pieces = split_sql($sql);
		
		if (($count = count($pieces))) {
			for ($i = 0; $i < $count; $i++) {
				if (!empty($pieces[$i]) && $pieces[$i] != '#') {
					$query = mysql_query($pieces[$i]);
					
					if (!$query) { 
					$error = true;
					?>
<div id="block">
<div id="title">Ошибка при выполнении запроса</div>
<div id="text"><?php echo mysql_errno() ?> / <?php echo mysql_error() ?></div>
<div id="text"><pre><?php echo $pieces[$i] ?></pre></div>
</div>
					<?php }
				}
			}
		}
		
		if (isset($error)) { ?>
<div id="block">
<div id="title">Установка не может быть продолжена</div>
<div id="text">При создании таблиц в БД произошли ошибки</div>
</div>
		<?php } else {
			// Выполнение инсталляционных запросов
			$sql = array();
			$sql[] = sprintf("insert into users (user_login, user_password, user_email, user_admin_privilege, user_register, user_last_visit, user_theme) values ('%s', '%s', '%s', '1', %d, %d, '%s')", $_POST['user_login'], md5(md5($_POST['user_password'])), $_POST['user_email'], time(), time(), 'standart');
			$sql[] = sprintf("insert into blog_posts values (1, 1, 1, 'Установка Wap Blogs Engine завершена.', 'Ура! Вы установили Wap Blogs Engine 1.0c - систему для создания блоггерной социальной сети в WAP.\r\nВ этом релизе исправлены многочисленные ошибки, а также введены интересные фичи:\r\n- Возможность установки на должность не только группы, но и отдельного пользователя;\r\n- Возможность переноса записи из одного блога в другой (в т.ч. из личного в коллективный и наоборот);\r\n- Похожие публикации в просмотре записи;\r\n- Популярные метки, выбрать список популяных меток можно удобным API;\r\n- Просмотр комментариев пользователя;\r\n- Просмотр всех меток, отсортированных по частоте использования;\r\n- Прямой эфир;\r\n\r\nВсе изменения можно проследить в [url=../wb-docs/changelog.txt]change.log[/url].\r\nРаспростаняется на условиях [url=../wb-docs/changelog.txt]GNU General Public License 2[/url].', 'установка, Wap Blogs Engine', %d, 0, 0, '3', '4', '4', 0)", time());
			$sql[] = sprintf("insert into blogs values (1, '0', 'Новости', '', %d, 0)", time());
			$sql[] = "insert into blog_tags values (1, 'Wap Blogs Engine')";
			$sql[] = "insert into blog_tags values (1, 'установка')";
			
			foreach ($sql as $s) {
				mysql_query($s);
			}
		?>
<div id="block">
<div id="title">Установка успешно завершена!</div>
<div id="text"><a href="../login.php?l=<?php echo $_POST['user_login'] ?>&amp;p=<?php echo $_POST['user_password'] ?>">Авторизоваться на сайте и приступить к администированию</a></div>
</div>
		<?php }
	} while (0);
} elseif (isset($_GET['enter'])) { ?>
<form action="index.php" method="post">

<div id="block">
<div id="title">Параметры подключения к БД MySQL</div>
<div id="text">Сервер:<br /><input type="text" name="db_host" value="localhost" /></div>
<div id="text">Пользователь:<br /><input type="text" name="db_user" /></div>
<div id="text">Пароль:<br /><input type="password" name="db_password" /></div>
<div id="text">База данных:<br /><input type="text" name="db_name" /></div>
</div>
<div id="block">
<div id="title">Параметры пользователя</div>
<div id="text">
Логин:<br />
<span id="info">Только символы английского алфавита, цифры и знак подчеркивания<br />
Логин не может быть числом</span><br />
<input type="text" name="user_login" value="Administrator" />
</div>
<div id="text">
Пароль:<br />
<span id="info">Только символы английского алфавита и цифры</span><br />
<input type="password" name="user_password" />
</div>
<div id="text">
E-mail:<br />
<input type="text" name="user_email" />
</div>
</div>
<input type="submit" name="install" value="Продолжить" /> 
<input type="submit" value="Назад" />
</form>
<?php
} else {
$dirrectories = array (
	'wb-content' => '777',
	'wb-content/avators' => '777',
	'wb-content/fonts' => '755',
	'wb-includes' => '777',
	'wb-includes/plugins' => '755',
	'wb-includes/themes' => '755',
	'wb-temp' => '777',
	'wb-temp/cache' => '777'
);

$files = array (
	'.htaccess',
	'wb-includes/plugins/blogs.php',
	'wb-includes/plugins/cache.php',
	'wb-includes/plugins/friends.php',
	'wb-includes/antibot.php',
	'wb-includes/common.php',
	'wb-includes/constants.php',
	'wb-includes/enviroment.php',
	'wb-includes/sessions.php'
);
?>
<div id="block">
<div id="title">Проверка существования необходимых директорий</div>
<?php foreach ($dirrectories as $dir => $access) { ?>
<div id="text"><?php echo $dir ?> - <?php echo $access ?> - <?php echo is_dir('../' . $dir) && ($access == 755 || is_writable('../' . $dir)) ? 'ОК' : 'Ошибка' ?></div>
<?php } ?>
</div>

<div id="block">
<div id="title">Проверка существования необходимых файлов</div>
<?php foreach ($files as $file) { ?>
<div id="text"><?php echo $file ?> - <?php echo is_file('../' . $file) ? 'ОК' : 'Ошибка' ?></div>
<?php } ?>
</div>

<div id="block">
<div id="title">Проверка готовности сервера</div>
<div id="text">PHP - <?php echo version_compare(phpversion(), '4.4.0', '>') ? 'OK' : 'Ошибка' ?></div>
<div id="text">MySQL - <?php echo extension_loaded('mysql') ? 'OK' : 'Ошибка' ?></div>
<div id="text">MB String - <?php echo extension_loaded('mbstring') ? 'OK' : 'Ошибка' ?></div>
<div id="text">ZLib - <?php echo extension_loaded('zlib') ? 'OK' : 'Ошибка' ?></div>
<div id="text">GD - <?php echo extension_loaded('gd') ? 'OK' : 'Ошибка' ?></div>
</div>

Если все необходимые расширения PHP доступны, и все указанные файлы / дирректории существуют - <a href="index.php?enter">продолжите установку</a>.
<?php } ?>
</div>
<div id="foot">
&copy; 2009 Wap Blogs Engine
</div>
</body>
</html>